diff --git a/src/main/java/net/minecraft/client/util/helper/Colors.java b/src/main/java/net/minecraft/client/util/helper/Colors.java
index 39a9cf811..471359caf 100644
--- a/src/main/java/net/minecraft/client/util/helper/Colors.java
+++ b/src/main/java/net/minecraft/client/util/helper/Colors.java
@@ -19,7 +19,8 @@ public abstract class Colors {
 	public static final Color[] allFlagColors = new Color[16];
 	public static final Color[] allSignColors = new Color[16];
 	public static final Color[] allRedstoneColors = new Color[16];
-	
+	public static final Color[] allPortalColors = new Color[16];
+
 	public static void loadColors() {
 		fillColorArray("/assets/minecraft/textures/misc/colors_chat.png", allChatColors);
 		fillColorArray("/assets/minecraft/textures/misc/colors_planks.png", allPlankColors);
@@ -27,6 +28,7 @@ public abstract class Colors {
 		fillColorArray("/assets/minecraft/textures/misc/colors_lamps.png", allLampColors);
 		fillColorArray("/assets/minecraft/textures/misc/colors_flag.png", allFlagColors);
 		fillColorArray("/assets/minecraft/textures/misc/colors_redstone.png", allRedstoneColors);
+		fillColorArray("/assets/minecraft/textures/misc/colors_portal.png", allPortalColors);
 	}
 	
 	public static void fillColorArray(String path, Color[] colors) {
diff --git a/src/main/java/net/minecraft/client/world/WorldClient.java b/src/main/java/net/minecraft/client/world/WorldClient.java
index 639f0944d..e26ac9d9b 100644
--- a/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -157,6 +157,7 @@ public class WorldClient extends World {
     {
         super.setEntityDead(entity);
         forced.remove(entity);
+        reEntries.remove(entity);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/ActivatorBlock.java b/src/main/java/net/minecraft/core/block/ActivatorBlock.java
index e13060116..15db03bcf 100644
--- a/src/main/java/net/minecraft/core/block/ActivatorBlock.java
+++ b/src/main/java/net/minecraft/core/block/ActivatorBlock.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.LevelListener;
@@ -57,7 +58,7 @@ public class ActivatorBlock extends VeryRotatableEntityBlock
                 if (block != null) {
                     block.onActivatorInteract(world, x + xOffset, y + yOffset, z + zOffset, activator, direction);
                 } else {
-                    world.playBlockEvent(LevelListener.EVENT_DISPENSER_EMPTY, x, y, z, 0);
+                    world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "tile.activator.click", 1, 1);
                 }
             }
             else
@@ -65,6 +66,7 @@ public class ActivatorBlock extends VeryRotatableEntityBlock
                 Item item = itemStack.getItem();
                 item.onUseByActivator(itemStack, activator, world, random, x, y, z, px, py, pz, direction);
                 activator.nullDeadItems();
+                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "tile.activator.use", 1, 1);
                 world.playBlockEvent(LevelListener.EVENT_DISPENSER_PARTICLES, x, y, z, direction.getId());
             }
         } else {
@@ -114,16 +116,7 @@ public class ActivatorBlock extends VeryRotatableEntityBlock
         if(world.getSignal(x, y, z, Side.BOTTOM)) {
             return true;
         }
-        if(world.getSignal(x, y + 1, z - 1, Side.NORTH)) {
-            return true;
-        }
-        if(world.getSignal(x, y + 1, z + 1, Side.SOUTH)) {
-            return true;
-        }
-        if(world.getSignal(x - 1, y + 1, z, Side.WEST)) {
-            return true;
-        }
-        return world.getSignal(x + 1, y + 1, z, Side.EAST);
+        return false;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/BedrockBlock.java b/src/main/java/net/minecraft/core/block/BedrockBlock.java
index 7136fa1e5..fd2d67119 100644
--- a/src/main/java/net/minecraft/core/block/BedrockBlock.java
+++ b/src/main/java/net/minecraft/core/block/BedrockBlock.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
 
 public class BedrockBlock
@@ -15,7 +16,7 @@ public class BedrockBlock
 	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
         if (world.getBlockId(x, y - 1, z) == Blocks.GLOWSTONE.id) {
-            ((PortalBlock) Blocks.PORTAL_PARADISE).tryToCreatePortal(world, x, y, z);
+            ((PortalBlock) Blocks.PORTAL_PARADISE).tryToCreatePortal(world, x, y, z, DyeColor.SILVER);
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java b/src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java
index 6917f4f25..f6c97c0aa 100644
--- a/src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java
@@ -70,7 +70,7 @@ public class CacaoLeavesBlock extends BaseLeavesBlock implements IBonemealable {
         if(growthRate > 0)
         {
             if (player != null) {
-                world.playSoundAtEntity(player, player, "random.pop", 0.2F, 0.5f);
+                world.playSoundAtEntity(player, player, "item.pickup", 1, 1);
             }
             if(!world.isClientSide)
             {
diff --git a/src/main/java/net/minecraft/core/block/DispenserBlock.java b/src/main/java/net/minecraft/core/block/DispenserBlock.java
index 1cd953bfc..e79a0a7c5 100644
--- a/src/main/java/net/minecraft/core/block/DispenserBlock.java
+++ b/src/main/java/net/minecraft/core/block/DispenserBlock.java
@@ -104,7 +104,7 @@ public class DispenserBlock extends VeryRotatableEntityBlock
     @Override
     public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        boolean flag = world.hasNeighborSignal(x, y, z) || world.hasNeighborSignal(x, y + 1, z);
+        boolean flag = world.hasNeighborSignal(x, y, z);
         int meta = world.getBlockMetadata(x, y, z);
         if(flag && (meta & MASK_POWERED) == 0)
         {
diff --git a/src/main/java/net/minecraft/core/block/FireBlock.java b/src/main/java/net/minecraft/core/block/FireBlock.java
index ee4ee476b..df2735cd6 100644
--- a/src/main/java/net/minecraft/core/block/FireBlock.java
+++ b/src/main/java/net/minecraft/core/block/FireBlock.java
@@ -281,7 +281,7 @@ public class FireBlock extends Block {
 	@Override
 	public void onBlockPlacedByWorld(World world, int x, int y, int z) {
 		if (world.getBlockId(x, y - 1, z) == Blocks.OBSIDIAN.id
-				&& ((PortalBlock) Blocks.PORTAL_NETHER).tryToCreatePortal(world, x, y, z)) {
+				&& ((PortalBlock) Blocks.PORTAL_NETHER).tryToCreatePortal(world, x, y, z, null)) {
 			return;
 		}
 		if (!world.isBlockNormalCube(x, y - 1, z) && !canNeighborCatchFire(world, x, y, z)) {
diff --git a/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java b/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java
index 5a51483d1..442091669 100644
--- a/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java
+++ b/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java
@@ -84,7 +84,7 @@ public class FireflyLanternBlock extends Block{
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit)
     {
         world.setBlockRaw(x, y, z, 0);
-        world.playSoundAtEntity(player, player, "random.pop", 0.2F, 0.5f);
+        world.playSoundAtEntity(player, player, "item.pickup", 1f, 1f);
         if (!world.isClientSide)
         {
             world.dropItem(x, y, z, new ItemStack(itemSupplier.get(), 1, 0));
diff --git a/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java b/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java
index 7ab65c9c3..332cbfe1e 100644
--- a/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java
@@ -54,7 +54,7 @@ public class FloweringCherryLeavesBlock extends CherryLeavesBlock implements IBo
         if(growthRate > 0)
         {
             if (player != null) {
-                world.playSoundAtEntity(player, player, "random.pop", 0.2F, 0.5f);
+                world.playSoundAtEntity(player, player, "item.pickup", 1f, 1f);
             }
             if(!world.isClientSide)
             {
diff --git a/src/main/java/net/minecraft/core/block/JarBlock.java b/src/main/java/net/minecraft/core/block/JarBlock.java
index 63f6e3293..c425fbfac 100644
--- a/src/main/java/net/minecraft/core/block/JarBlock.java
+++ b/src/main/java/net/minecraft/core/block/JarBlock.java
@@ -72,7 +72,7 @@ public class JarBlock extends EntityBlock {
         if(player.getHeldItem() == null) {
             if (world.getBlockMetadata(x, y, z) == 0) {
                 world.setBlockWithNotify(x, y, z, 0);
-                world.playSoundAtEntity(player, player, "random.pop", 0.2F, 0.5f);
+                world.playSoundAtEntity(player, player, "item.pickup", 1f, 1f);
                 if (!world.isClientSide) {
                     world.dropItem(x, y, z, new ItemStack(itemSupplier.get(), 1, 0));
                 }
@@ -83,7 +83,7 @@ public class JarBlock extends EntityBlock {
                 if (flowerInPot > 0 && hasTag(flowerInPot, BlockTags.PLANTABLE_IN_JAR)) {
                     tileEntity.flowerInPot = 0;
                     world.setBlockMetadataWithNotify(x, y, z, 0);
-                    world.playSoundAtEntity(player, player, "random.pop", 0.2F, 0.5f);
+                    world.playSoundAtEntity(player, player, "item.pickup", 1f, 1f);
                     if (!world.isClientSide) {
                         world.dropItem(x, y, z, new ItemStack(flowerInPot, 1, flowerData));
                     }
diff --git a/src/main/java/net/minecraft/core/block/PortalBlock.java b/src/main/java/net/minecraft/core/block/PortalBlock.java
index 200d55d75..99308e108 100644
--- a/src/main/java/net/minecraft/core/block/PortalBlock.java
+++ b/src/main/java/net/minecraft/core/block/PortalBlock.java
@@ -1,23 +1,42 @@
 package net.minecraft.core.block;
 
+import net.minecraft.client.Minecraft;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.helper.Sides;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.chunk.ChunkPosition;
+import org.jetbrains.annotations.Nullable;
 
+import java.util.ArrayList;
+import java.util.HashSet;
+import java.util.List;
 import java.util.Random;
+import java.util.Set;
 
 // Referenced classes of package net.minecraft.src:
 //            BlockBreakable, Material, IBlockAccess, World, 
 //            Block, FireBlock, Entity, AxisAlignedBB
 
-public class PortalBlock extends TransparentBlock
+public class PortalBlock extends TransparentBlock implements IPainted
 {
+    public static final int MAX_PORTAL_SIZE = 32;
+    public static final int MASK_COLOR = 0b1111_0000;
+    public static final int MASK_ROTATION = 0b0000_0011;
+    public static final int MASK_COLOR_SET = 0b0000_1000;
+
+    public static final int ORIENTATION_X = 0;
+    public static final int ORIENTATION_Z = 1;
 	public int targetDimension;
 	public int portalFrameId;
 	public int portalTriggerId;
@@ -73,7 +92,7 @@ public class PortalBlock extends TransparentBlock
     
     public int[] getPortalDims(World world, int x, int y, int z, boolean swapOrientation, boolean expectMiddle)
     {
-        int maxDims = 32;
+        int maxDims = MAX_PORTAL_SIZE;
         
         int ox = x;
         int oy = y;
@@ -255,8 +274,11 @@ public class PortalBlock extends TransparentBlock
         return new int[] { orientation ? 1 : 0, x, y, z, maxBoundA, maxBoundY };
     }
 
-    public boolean tryToCreatePortal(World world, int x, int y, int z)
+    public boolean tryToCreatePortal(World world, int x, int y, int z, @Nullable DyeColor color)
     {
+        if (color == null) {
+            color = DyeColor.PURPLE;
+        }
         int[] bounds = getPortalDims(world, x, y, z, false);
 
         if (bounds == null) return false;
@@ -270,12 +292,19 @@ public class PortalBlock extends TransparentBlock
         {
             for(int ry = 1; ry < bounds[5]; ry++)
             {
-                world.setBlockAndMetadata(x + (bounds[0] == 0 ? ra : 0), y + ry, z + (bounds[0] == 1 ? ra : 0), this.id, bounds[0] & 0x1);
+                int _x = x + (bounds[0] == 0 ? ra : 0);
+                int _y = y + ry;
+                int _z = z + (bounds[0] == 1 ? ra : 0);
+                world.setBlockAndMetadata(_x, _y, _z, this.id, bounds[0] & 0x1);
             }
 
         }
 
-        world.setBlockMetadata(x + (bounds[0] == 0 ? 1 : 0), y + 1, z + (bounds[0] == 1 ? 1 : 0), (bounds[0] & 0xF) | 0x2);
+        int _x = x + (bounds[0] == ORIENTATION_X ? 1 : 0);
+        int _y = y + 1;
+        int _z = z + (bounds[0] == ORIENTATION_Z ? 1 : 0);
+        world.setBlockMetadata(_x, _y, _z, (bounds[0] & 0xF) | 0x2);
+        setColor(world, _x, _y, _z, color);
         
         world.markBlocksDirty(x + (bounds[0] == 0 ? 1 : 0), y + 1, z + (bounds[0] == 1 ? 1 : 0), x + (bounds[0] == 0 ? bounds[4] : 0), y + bounds[5], z + (bounds[0] == 1 ? bounds[4] : 0));
 
@@ -310,9 +339,21 @@ public class PortalBlock extends TransparentBlock
     @Override
     public void onEntityCollidedWithBlock(World world, int x, int y, int z, Entity entity)
     {
+        if (entity instanceof ItemEntity && ((ItemEntity) entity).item != null && ((ItemEntity) entity).item.itemID == Items.DYE.id) {
+            ItemEntity itemEntity = (ItemEntity) entity;
+            DyeColor color = DyeColor.colorFromItemMeta(itemEntity.item.getMetadata());
+            if (getColor(world, x, y, z) != color) {
+                setColor(world, x, y, z, color);
+                itemEntity.item.stackSize--;
+                if (itemEntity.item.stackSize <= 0) {
+                    itemEntity.remove();
+                    return;
+                }
+            }
+        }
         if(entity.vehicle == null && entity.passenger == null)
         {
-            entity.handlePortal(this.id);
+            entity.handlePortal(this.id, getColor(world, x, y, z));
         }
     }
 
@@ -326,24 +367,87 @@ public class PortalBlock extends TransparentBlock
         }
         for(int l = 0; l < 4; l++)
         {
-            double d = (double) x + rand.nextFloat();
-            double d1 = (double) y + rand.nextFloat();
-            double d2 = (double) z + rand.nextFloat();
+            double px = (double) x + rand.nextFloat();
+            double py = (double) y + rand.nextFloat();
+            double pz = (double) z + rand.nextFloat();
             int i1 = rand.nextInt(2) * 2 - 1;
-            double d3 = ((double) rand.nextFloat() - 0.5D) * 0.5D;
-            double d4 = ((double) rand.nextFloat() - 0.5D) * 0.5D;
-            double d5 = ((double) rand.nextFloat() - 0.5D) * 0.5D;
+            double xd = (rand.nextDouble() - 0.5D) * 0.5D;
+            double yd = (rand.nextDouble() - 0.5D) * 0.5D;
+            double zd = (rand.nextDouble() - 0.5D) * 0.5D;
             if(world.getBlockId(x - 1, y, z) == id || world.getBlockId(x + 1, y, z) == id)
             {
-                d2 = (double) z + 0.5D + 0.25D * (double)i1;
-                d5 = rand.nextFloat() * 2.0D * (double)i1;
+                pz = (double) z + 0.5D + 0.25D * (double)i1;
+                zd = rand.nextFloat() * 2.0D * (double)i1;
             } else
             {
-                d = (double) x + 0.5D + 0.25D * (double)i1;
-                d3 = rand.nextFloat() * 2.0D * (double)i1;
+                px = (double) x + 0.5D + 0.25D * (double)i1;
+                xd = rand.nextFloat() * 2.0D * (double)i1;
+            }
+            world.spawnParticle("portal", px, py, pz, xd, yd, zd, fromMetadata(meta).blockMeta);
+        }
+
+    }
+
+    @Override
+    public DyeColor fromMetadata(int meta) {
+        if ((meta & MASK_COLOR_SET) == 0) return DyeColor.PURPLE;
+        return DyeColor.colorFromBlockMeta((meta & MASK_COLOR) >> 4);
+    }
+
+    @Override
+    public int toMetadata(DyeColor color) {
+        return (color.blockMeta << 4) & MASK_COLOR;
+    }
+
+    @Override
+    public int stripColorFromMetadata(int meta) {
+        return meta & ~MASK_COLOR;
+    }
+
+    @Override
+    public void removeDye(World world, int x, int y, int z) {
+        final int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockAndMetadataWithNotify(x, y, z, Blocks.STAIRS_PLANKS_OAK.id, stripColorFromMetadata(meta));
+    }
+
+    @Override
+    public DyeColor getColor(World world, int x, int y, int z) {
+        return IPainted.super.getColor(world, x, y, z);
+    }
+
+    // TODO implement block updates without causing lag spikes
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        int[] bounds = getPortalDims(world, x, y, z, true);
+        if (bounds == null) {
+            world.setBlockWithNotify(x, y, z, 0);
+            return;
+        }
+
+        int px = bounds[1];
+        int py = bounds[2];
+        int pz = bounds[3];
+
+        for(int ra = 1; ra < bounds[4]; ra++)
+        {
+            for(int ry = 1; ry < bounds[5]; ry++)
+            {
+                int _x = px + (bounds[0] == ORIENTATION_X ? ra : 0);
+                int _y = py + ry;
+                int _z = pz + (bounds[0] == ORIENTATION_Z ? ra : 0);
+                setColorRaw(world, _x, _y, _z, color);
             }
-            world.spawnParticle("portal", d, d1, d2, d3, d4, d5, 0);
         }
+//        if (bounds[0] == ORIENTATION_X) {
+//            world.markBlocksDirty(px + 1, py + 1, pz, px + bounds[4], py + bounds[5], pz);
+//        } else {
+//            world.markBlocksDirty(px, py + 1, pz + 1, px, py + bounds[5], pz + bounds[4]);
+//        }
+    }
+
 
+    private void setColorRaw(World world, int x, int y, int z, DyeColor color) {
+        final int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockMetadataWithNotify(x, y, z, stripColorFromMetadata(meta) | toMetadata(color) | MASK_COLOR_SET);
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/TNTBlock.java b/src/main/java/net/minecraft/core/block/TNTBlock.java
index d622a87e2..fc84b92cd 100644
--- a/src/main/java/net/minecraft/core/block/TNTBlock.java
+++ b/src/main/java/net/minecraft/core/block/TNTBlock.java
@@ -62,7 +62,7 @@ public class TNTBlock extends Block {
 		world.setBlockWithNotify(x, y, z, 0);
 		TNTPrimedEntity e = new TNTPrimedEntity(world, x + 0.5F, y + 0.5F, z + 0.5F);
 		world.entityJoinedWorld(e);
-		world.playSoundAtEntity(null, e, "random.fuse", 1.0F, 1.0F);
+		world.playSoundAtEntity(null, e, "tile.tnt.fuse", 1.0F, 1.0F);
 		if (player != null && player.inventory.getCurrentItem() != null && (player.inventory.getCurrentItem().getItem() instanceof FireStrikerItem)) {
 			player.inventory.getCurrentItem().damageItem(1, player);
 		}
diff --git a/src/main/java/net/minecraft/core/block/entity/SensorBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/SensorBlockEntity.java
index eb8c4c438..ac2d70083 100644
--- a/src/main/java/net/minecraft/core/block/entity/SensorBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/SensorBlockEntity.java
@@ -87,7 +87,7 @@ public class SensorBlockEntity extends BlockEntity {
 		}
 		
 		if(shouldBeActive && id == Blocks.MOTION_SENSOR_IDLE.id) {
-			worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5, y + 0.5, z + 0.5, "random.breath", 0.5f, worldObj.rand.nextFloat());
+			worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5, y + 0.5, z + 0.5, "tile.sensor_block.sense", 1f, worldObj.rand.nextFloat());
 			updateSensorBlockState(true, worldObj);
 		}
 		if(!shouldBeActive && id == Blocks.MOTION_SENSOR_ACTIVE.id) {
@@ -123,7 +123,7 @@ public class SensorBlockEntity extends BlockEntity {
 		}
 
 		if(shouldBeActive && id == Blocks.MOTION_SENSOR_IDLE.id) {
-			world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5, y + 0.5, z + 0.5, "random.breath", 0.5f, world.rand.nextFloat());
+			world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5, y + 0.5, z + 0.5, "tile.sensor_block.sense", 1f, world.rand.nextFloat());
 			updateSensorBlockState(true, world);
 		}
 		if(!shouldBeActive && id == Blocks.MOTION_SENSOR_ACTIVE.id) {
diff --git a/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
index b4b337360..4d3f94909 100644
--- a/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
@@ -23,11 +23,13 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
+import java.util.Objects;
 import java.util.Random;
 
 public class TrommelBlockEntity extends BlockEntity
@@ -440,39 +442,61 @@ public class TrommelBlockEntity extends BlockEntity
     }
 
     private void simulateTrommelDrops(int passes, ItemStack blockToTest){
-        Map<Object, Integer> trommelDropMap = new HashMap<>();
+        Map<Object, ResultEntry> trommelDropMap = new HashMap<>();
         System.out.println();
         System.out.println("Generating simulation of Trommel loot for block: " + blockToTest.getItem().namespaceID);
         for(int i = 0; i < passes; i++){
             ItemStack itemStack = this.getItemResult(blockToTest);
             if(itemStack != null){
                 Item item = itemStack.getItem();
-                trommelDropMap.put(item.namespaceID, trommelDropMap.getOrDefault(item.namespaceID, 0) + 1);
+                if (!trommelDropMap.containsKey(item.namespaceID)) {
+                    trommelDropMap.put(item.namespaceID, new ResultEntry(item));
+                }
+                trommelDropMap.get(item.namespaceID).addStack(itemStack);
             } else {
-                trommelDropMap.put("NULL", trommelDropMap.getOrDefault("NULL", 0) + 1);
+                if (!trommelDropMap.containsKey("NULL")) {
+                    trommelDropMap.put("NULL", new ResultEntry(null));
+                }
+                trommelDropMap.get("NULL").addStack(null);
             }
         }
-        System.out.println("Trommel loot sampling " + passes + " passes:");
+        System.out.printf("Trommel loot sampling %s (%.2f stacks) passes:%n", passes, passes/64f);
         for (Item item : Item.itemsList)
         {
-            if (item == null) continue;;
-            Integer amount = trommelDropMap.get(item.namespaceID);
-            float percentage;
-            if (amount != null)
-            {
-                percentage = amount / (float) (passes);
-                percentage *= 100;
-            } else {
-                percentage = 0.0f;
-            }
-            if(amount != null) {
-                System.out.println("        " + item.namespaceID + " yield: " + amount  + String.format(" (%.2f stacks) - ", (float)(amount)/64F) + String.format("%.2f", percentage) + "%");
+            if (item == null) continue;
+            ResultEntry entry = trommelDropMap.get(item.namespaceID);
+            if (entry != null) {
+                System.out.println(entry);
             }
         }
         if (trommelDropMap.get("NULL") != null) {
-            float percentage = trommelDropMap.get("NULL") / (float) (passes);
-            percentage *= 100;
-            System.out.println("        " + "NULL" + " yield: " + trommelDropMap.get("NULL")  + " (" + MathHelper.floor_float((float)(trommelDropMap.get("NULL"))/64F) + " stacks) - " + String.format("%.2f", percentage) + "%");
+            System.out.println(trommelDropMap.get("NULL"));
+        }
+    }
+
+    private static class ResultEntry {
+        public @Nullable Item item;
+        public int totalItems = 0;
+        public int timesOccured = 0;
+
+        public ResultEntry(Item item) {
+            this.item = item;
+        }
+
+        public void addStack(ItemStack stack) {
+            if (this.item == null) {
+                assert stack == null : "stack must be null for a null item!";
+                timesOccured++;
+            } else {
+                assert item == stack.getItem() : "stack's item must match current item!";
+                timesOccured++;
+                totalItems += stack.stackSize;
+            }
+        }
+
+        @Override
+        public String toString() {
+            return String.format("\t%s - Occurred: %sx - Total Items: %s (%.2f stacks)", item == null ? "NULL" : item.namespaceID, timesOccured, totalItems, totalItems/64f);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java b/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java
index ca052330d..5be57f85e 100644
--- a/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java
@@ -2,6 +2,7 @@ package net.minecraft.core.block.piston;
 
 import java.util.ArrayList;
 
+import net.minecraft.client.Minecraft;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.BlockEntity;
@@ -330,8 +331,7 @@ public class PistonBaseBlock extends Block
                 return false;
             }
             if (Block.blocksList[blockId].getPistonPushReaction(world, xo, yo, zo) == Material.PISTON_DESTROY_ON_PUSH) {
-                Block.blocksList[blockId].dropBlockWithCause(world, EnumDropCause.WORLD, xo, yo, zo, world.getBlockMetadata(xo, yo, zo), null, null);
-                world.setBlockWithNotify(xo, yo, zo, 0);
+                Block.blocksList[blockId].dropBlockWithCause(world, EnumDropCause.WORLD, xo, yo, zo, world.getBlockMetadata(xo, yo, zo), world.getBlockEntity(xo, yo, zo), null);
                 break;
             }
             if (blocks == maxPushedBlocks) {
diff --git a/src/main/java/net/minecraft/core/entity/Entity.java b/src/main/java/net/minecraft/core/entity/Entity.java
index db8f2bf61..aaefe2bf4 100644
--- a/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/src/main/java/net/minecraft/core/entity/Entity.java
@@ -3,6 +3,7 @@ package net.minecraft.core.entity;
 import java.util.List;
 import java.util.Random;
 
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.ICarriable;
 import org.jetbrains.annotations.Nullable;
 
@@ -1295,7 +1296,7 @@ public abstract class Entity
         return null;
     }
 
-    public void handlePortal(int portalTileId)
+    public void handlePortal(int portalBlockId, DyeColor portalColor)
     {
     }
 
diff --git a/src/main/java/net/minecraft/core/entity/ItemEntity.java b/src/main/java/net/minecraft/core/entity/ItemEntity.java
index a176c3a65..048f47f69 100644
--- a/src/main/java/net/minecraft/core/entity/ItemEntity.java
+++ b/src/main/java/net/minecraft/core/entity/ItemEntity.java
@@ -226,7 +226,7 @@ public class ItemEntity extends Entity
 				}
 				
 				if(item.stackSize <= 0) {
-					world.playSoundAtEntity(player, this, "random.pop", 0.2F, ((random.nextFloat() - random.nextFloat()) * 0.7F + 1.0F) * 2.0F);
+					world.playSoundAtEntity(player, this, "item.pickup", 1F, ((random.nextFloat() - random.nextFloat()) * 0.7F + 1.0F) * 4.0F);
 					player.onItemPickup(this, item);
 				}
 
diff --git a/src/main/java/net/minecraft/core/entity/Mob.java b/src/main/java/net/minecraft/core/entity/Mob.java
index e8a613df7..efa11e189 100644
--- a/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/src/main/java/net/minecraft/core/entity/Mob.java
@@ -806,7 +806,7 @@ public abstract class Mob extends Entity
             {
                 xd *= 0.8D;
                 zd *= 0.8D;
-                world.playSoundAtEntity(null, this, "random.fuse", (float)Math.sqrt(speedSquared) * 2.0f + random.nextFloat() * 0.2f - 0.25f, 1.75f + (random.nextFloat() * 0.4f - 0.2f));
+                world.playSoundAtEntity(null, this, "random.skate", (float)Math.sqrt(speedSquared) * 2.0f + random.nextFloat() * 0.2f - 0.25f, 1.75f + (random.nextFloat() * 0.4f - 0.2f));
             }
             if ((lastStrafe < 0 && moveStrafing > 0) || (lastStrafe > 0 && moveStrafing < 0))
             {
@@ -822,7 +822,7 @@ public abstract class Mob extends Entity
                     xd = newMotionX;
                     zd = newMotionZ;
                 }
-                world.playSoundAtEntity(null, this, "random.fuse", (float)Math.sqrt(speedSquared) * 0.75f + random.nextFloat() * 0.2f, 2f + (random.nextFloat() * 0.4f - 0.2f));
+                world.playSoundAtEntity(null, this, "random.skate", (float)Math.sqrt(speedSquared) * 0.75f + random.nextFloat() * 0.2f, 2f + (random.nextFloat() * 0.4f - 0.2f));
             }
             if (moveStrafing != 0) lastStrafe = moveStrafing;
         }
diff --git a/src/main/java/net/minecraft/core/entity/monster/CreeperMob.java b/src/main/java/net/minecraft/core/entity/monster/CreeperMob.java
index ecb2eba00..c405fc289 100644
--- a/src/main/java/net/minecraft/core/entity/monster/CreeperMob.java
+++ b/src/main/java/net/minecraft/core/entity/monster/CreeperMob.java
@@ -74,7 +74,7 @@ public class CreeperMob extends Monster
             if(i > 0 && timeSinceIgnited == 0)
             {
             	if(!world.isClientSide) {
-                    world.playSoundAtEntity(null, this, "random.fuse", 1.0F, 0.5F);
+                    world.playSoundAtEntity(null, this, "mob.creeper.fuse", 1.0F, 1.0F);
             	}
             }
             timeSinceIgnited += i;
@@ -126,7 +126,7 @@ public class CreeperMob extends Monster
             if(timeSinceIgnited == 0)
             {
             	if(!world.isClientSide) {
-            		world.playSoundAtEntity(null, this, "random.fuse", 1.0F, 0.5F);	
+            		world.playSoundAtEntity(null, this, "mob.creeper.fuse", 1.0F, 1.0F);
             	}
             }
             setCreeperState(1);
